#include <arduino.h>

#define Taster_1 2    //platine
//#define Taster_1 4    //prototyp
#define Taster_2 14
#define Taster_E 8
#define Encoder_A 7
#define Encoder_B 6
#define LED_G 9
#define LED_R 15
#define Poti_Pin 7

int* encoderadr;
int encoderval;

int8_t encoder_aw, encoder_bw, encoder_t, encoder_st;
unsigned long mymil;

//#############################################
void Mikulino_Setup() {
    encoderadr=&encoderval;
    Serial.begin(9600);	// Debugging only
    Serial.println(">");
        pinMode(Taster_1, INPUT_PULLUP);
        pinMode(Taster_2, INPUT_PULLUP);
        pinMode(Taster_E, INPUT_PULLUP);
        pinMode(Encoder_A, INPUT_PULLUP);
        pinMode(Encoder_B, INPUT_PULLUP);
        pinMode(LED_R, OUTPUT);
        pinMode(LED_G, OUTPUT);        
        pinMode(Poti_Pin, INPUT);
        digitalWrite(Encoder_A, HIGH);
        digitalWrite(Encoder_B, HIGH);
        digitalWrite(Taster_1, HIGH);
        digitalWrite(Taster_2, HIGH);        
        digitalWrite(Taster_E, HIGH);       
                     

    // enable tick-er  - um zu verstehen, wie es funktioniert :-) Prozessor-Handbuch lesen
     OCR0A=0x80;     
     TIMSK0 |= _BV(OCIE0A);   
   
#ifdef Mikulino_Display
    // Display Initialisation - hier werden 1kByte RAM "verbraten"
        display.begin(SSD1306_SWITCHCAPVCC, 0x3C);
        display.clearDisplay();
#endif
     // Anfangsstellung vom Encoder (Drehgeber) ermitteln
     encoder_aw=digitalRead(Encoder_A);     
     if (encoder_aw==0) encoder_t=1; else encoder_t=-1;
     encoder_st=0;
}

//#############################################
// Mit dieser Funktion kann jede beliebige int-Variable auf den Drehgeber geschaltet werden 
// set_encoder(&ivar)
// ab jetzt wird durch Drehen des Encoders ivar rauf- oder runtergezählt

void set_encoder(int* encpar) {
  encoderadr=encpar;
  }
//#############################################
// Diese Funktion wird alle 976 uSekunden aufgerufen Int-Service !!! siehe "enable tick-er"
SIGNAL(TIMER0_COMPA_vect) {
 tick_976us();
 mymil+=1;
 if (mymil==1024) {
   tick_sek();      // alle Sekunde  1024*976us = 1 Sek
   mymil=0;
   }
   // sehr code und laufzeitoptimierte Statemachine zur Behandlung des Encoders - nicht auf Lesbarkeit hin getrimmt :-)
   encoder_aw=digitalRead(Encoder_A);
   encoder_bw=digitalRead(Encoder_B);
   if (encoder_st==0) {
     *encoderadr+=encoder_t*(encoder_aw-encoder_bw);
     if (encoder_aw!=encoder_bw) encoder_st++;
     }
   else {
     if (encoder_aw==encoder_bw) {
      encoder_st=0;
//    nachfolgende Zeile ist gleichbedeutend mit: if (encoder_aw==1) encoder_t=-1; else encoder_t=1;
      encoder_t=1-(2*encoder_aw);   // Annahme: Compiler optimiert zu (ancoder_aw<<1)
       }
     }
}

//#############################################
#define Taster1 !digitalRead(Taster_1)
#define Taster2 !digitalRead(Taster_2)
#define TasterE !digitalRead(Taster_E)
#define Poti analogRead(Poti_Pin)

#define AIN6 analogRead(6)    // Standard Analog-Eingang

void LedR(boolean onof) {
  digitalWrite(LED_R, onof);
  } 
void LedG(boolean onof) {
  digitalWrite(LED_G, onof);
  } 
void DimG(byte dimv) {       // G bedeutet grüne LED, dimmen funktioniert nur bei der
  analogWrite(LED_G, dimv);
  } 
    
      
  
  
